;(function ($) {
  function c(msg) {
    console.log(msg);
  }

  function cc(msg, msg2) {
    console.log(msg, msg2);
  }

  var app = {
    selected_logs: [],
    selected_rows: [],
  };
  var PE;//Popup Editor
  var MPP;//Master Popups
  var xbox;//Xbox Framework


  app.init = function () {
    PE.$post_body = $('body.post-type-master-popups #post-body');
    app.$form = $('#settings-cookieplus');
    app.$table_consent_logs = app.$form.find('#cpp-table-cookie-logs-overview');
    app.$table_cookie_list = app.$form.find('#cpp-table-cookie-list');

    app.init_table_cookie_logs_overview();
    app.init_table_cookie_list();

    app.on_change_use_popup_has_editor();
    app.go_scan_cookies();
    app.load_consent_logs();

    app.$form.on('click', '.ampp-delete-log', app.delete_consent_log);
    app.$form.on('click', '.ampp-delete-all-logs', app.delete_all_consent_logs);
    app.$form.on('click', '.ampp-checkbox-all-logs', app.on_click_checkbox_delete_all_consent_logs);



  };

  app.go_scan_cookies = function () {
    app.$form.on('click', '.cpp-btn-go-scan-cookies', function (e) {
      app.$form.find('li.tab-item-main-cookie-list a').trigger('click');
    });
  };

  app.load_consent_logs = function () {
    app.$form.on('click', '#btn-load-consent-logs', function(){
      $(this).find('i').addClass('xbox-icon-spin');
      app.$form.find('#xbox-save').trigger('click');
    });
  };

  app.get_cookies = function () {
    var pairs = document.cookie.split(";");
    var cookies = {};
    for (var i = 0; i < pairs.length; i++) {
      var pair = pairs[i].split("=");
      cookies[(pair[0] + '').trim()] = unescape(pair.slice(1).join('='));
    }
    return cookies;
  };

  app.init_table_cookie_logs_overview = function () {
    if( !app.$table_consent_logs.length ){
      return;
    }
    app.ConsentLogsTable = app.$table_consent_logs.DataTable({
      "dom": "Blfrtip",
      "buttons": [
        {
          extend: 'csv',
          text: 'Export CSV',
          className: 'xbox-btn xbox-btn-bluepurple xbox-btn-small',
        },
        {
          extend: 'excel',
          text: 'Export Excel',
          className: 'xbox-btn xbox-btn-bluepurple xbox-btn-small',
        },
        {
          extend: 'colvis',
          columns: ':not(.noHide)',
          className: 'xbox-btn xbox-btn-bluepurple xbox-btn-small',
        }
      ],
      'lengthMenu': [[10, 20, 50, 100, 200, 500, -1], [10, 20, 50, 100, 200, 500, "All"]],
      'pageLength': 50,
      //'searching': false,
      //'lengthChange': false,
      "bSort" : false,

      "oLanguage": {
        "sLengthMenu": "Display _MENU_ consent logs",
        "sZeroRecords": "No consent logs found",
        "sInfo": "Showing _START_ to _END_ of _TOTAL_ consent logs",
        "sInfoFiltered": " - filtering from _MAX_ consent logs",
        "sInfoEmpty": "No consent logs to show",
      }
    });
  };

  app.init_table_cookie_list = function () {
    app.$table_cookie_list.DataTable({
      "dom": "lfrtip",
      "buttons": [
      ],
      'lengthMenu': [[50, 100, 200, 500, -1], [50, 100, 200, 500, "All"]],
      'pageLength': 50,
      'searching': false,
      'lengthChange': false,
      "bSort" : false,

      "oLanguage": {
        "sLengthMenu": "Display _MENU_ cookies",
        "sZeroRecords": "No cookies found",
        "sInfo": "Showing _START_ to _END_ of _TOTAL_ cookies",
        "sInfoFiltered": " - filtering from _MAX_ cookies",
        "sInfoEmpty": "No cookies to show",
      }
    });
  };

  app.on_change_use_popup_has_editor = function () {
    PE.$post_body.on('xbox_changed_value', '.xbox-field-id-mpp_cookieplus-use-has-cookie-settings .xbox-element', function (event, value) {
      //xbox.set_field_value(PE.$post_body.find('.xbox-field-id-mpp_use-wp-editor'), value);
      xbox.set_field_value(PE.$post_body.find('.xbox-field-id-mpp_preloader-show'), value == 'on' ? 'off' : 'on');
      xbox.set_field_value(PE.$post_body.find('.xbox-field-id-mpp_open-duration'), value == 'on' ? '600' : '800');
      xbox.set_field_value(PE.$post_body.find('.xbox-field-id-mpp_close-duration'), value == 'on' ? '600' : '700');
    });

    PE.$post_body.on('xbox_changed_value', '.xbox-field-id-mpp_cookieplus-disclaimer-enabled .xbox-element', function (event, value) {
      xbox.set_field_value(PE.$post_body.find('.xbox-field-id-mpp_disclaimer-enabled'), value);
    });
  };


  app.delete_consent_log = function(event){
    event.preventDefault();

    $.xboxConfirm({
      title: XBOX_JS.text.remove_item_popup.title,
      content: XBOX_JS.text.remove_item_popup.content,
      confirm_class: 'xbox-btn-blue',
      confirm_text: XBOX_JS.text.popup.accept_button,
      cancel_text: XBOX_JS.text.popup.cancel_button,
      onConfirm: function () {
        app._delete_consent_log(event);
      }
    });
  };

  app._delete_consent_log = function(event){
    var $btn = $(event.currentTarget);
    var $tr = $btn.closest('tr');
    var id = $tr.data('id');
    var data = {
      action: 'cpp_delete_consent_logs',
      logs: [id],
    };

    app.reset_selected_consent_logs();

    MPP.ajax({
      data: data,
      beforeSend: function () {
        $btn.find('i').attr('class', '').addClass('mpp-icon mpp-icon-spinner mpp-icon-spin ampp-loader xbox-color-dark');
      },
      success: function (response) {
        if (response && response.success) {
          app.ConsentLogsTable.row($tr).remove().draw();
          app.update_total_consent_logs(response);
        }
      },
      complete: function (jqXHR, textStatus) {
        $btn.find('i').attr('class', '').addClass('xbox-icon xbox-icon-trash xbox-color-red');
      }
    });
  };

  app.update_total_consent_logs = function(response){
    app.$form.find('.cpp-consent-logs .cpp-number').text(response.total);
    app.$form.find('.info-total-consent-logs').text(response.total);
  };

  app.on_click_checkbox_delete_all_consent_logs = function(event){
    var $rows = app.$table_consent_logs.find('tbody tr');
    var is_checked = $(this).is(':checked');
    var logs = [];
    var $selected_rows = [];
    $rows.each(function(index, element){
      var $row = $(element);
      if( is_checked ){
        $row.addClass('ampp-remove-row');
        var log_id = $row.data('id');
        logs.push(log_id);
        $selected_rows.push($row);
      } else {
        $row.removeClass('ampp-remove-row');
      }
    });
    app.selected_logs = logs;
    app.selected_rows = $selected_rows;
  };

  app.delete_all_consent_logs = function(event){
    event.preventDefault();
    var $checkbox = app.$table_consent_logs.find('.ampp-checkbox-all-logs');
    var title = XBOX_JS.text.remove_item_popup.title + ' ' + app.selected_logs.length + ' Consent Logs';
    var content = XBOX_JS.text.remove_item_popup.content;
    var hide_cancel = false;
    if( ! $checkbox.is(':checked') ){
      hide_cancel = true;
      title = 'Activate the checkbox';
      content = 'Please select rows';
    } else if( app.selected_logs.length === 0 ){
      hide_cancel = true;
      title = 'No Consent Logs found';
      content = 'There are no Consent Logs to delete.';
    }

    $.xboxConfirm({
      title: title,
      content: content,
      confirm_class: 'xbox-btn-blue',
      confirm_text: XBOX_JS.text.popup.accept_button,
      cancel_text: XBOX_JS.text.popup.cancel_button,
      hide_cancel: hide_cancel,
      //hide_confirm: false,
      onConfirm: function () {
        if($checkbox.is(':checked') && app.selected_logs.length > 0 ){
          app._delete_all_consent_logs(event);
        }
      }
    });
    return false;
  };

  app._delete_all_consent_logs = function (event) {
    var $btn = $(event.currentTarget);
    var data = {
      action: 'cpp_delete_consent_logs',
      logs: app.selected_logs,
    };
    MPP.ajax({
      data: data,
      beforeSend: function () {
        $btn.find('i').attr('class', '').addClass('mpp-icon mpp-icon-spinner mpp-icon-spin ampp-loader xbox-color-dark');
      },
      success: function (response) {
        if (response && response.success) {
          app.selected_rows.forEach(function($tr, index, arr ){
            app.ConsentLogsTable.row($tr).remove().draw();
          });
          app.update_total_consent_logs(response);
        }
      },
      complete: function (jqXHR, textStatus) {
        app.reset_selected_consent_logs();
        $btn.find('i').attr('class', '').addClass('xbox-icon xbox-icon-trash xbox-color-red');
      }
    });
  };

  app.reset_selected_consent_logs = function (event) {
    app.selected_logs = [];
    app.selected_rows = [];
    app.$form.find('.ampp-checkbox-all-logs').prop('checked', false);
    app.$table_consent_logs.find('tbody tr').removeClass('ampp-remove-row');
  };

  //Document Ready
  $(function () {
    xbox = window.XBOX;
    MPP = window.AdminMasterPopup;
    PE = window.MppPopupEditor;

    if (xbox && MPP && PE) {
      app.init();
    }
  });

  return app;


})(jQuery);