<?php namespace MasterPopupsAddonCookiePlus\Includes;

class Ajax {
    public $plugin;
    protected static $instance = null;

    /*
    |---------------------------------------------------------------------------------------------------
    | Constructor
    |---------------------------------------------------------------------------------------------------
    */
    private function __construct( $plugin ){
        $this->plugin = $plugin;


        add_action( 'wp_ajax_cpp_delete_consent_logs', array( $this, 'delete_consent_logs' ) );
        add_action( 'wp_ajax_nopriv_cpp_delete_consent_logs', array( $this, 'delete_consent_logs' ) );

    }

    /*
    |---------------------------------------------------------------------------------------------------
    | Singleton
    |---------------------------------------------------------------------------------------------------
    */
    private function __clone(){
    }//Stopping Clonning of Object

    private function __wakeup(){
    }//Stopping unserialize of object

    public static function get_instance( $plugin = null ){
        if( null === self::$instance ){
            self::$instance = new self( $plugin );
        }
        return self::$instance;
    }

    /*
    |---------------------------------------------------------------------------------------------------
    | Valida Plugin Nonce Ajax
    |---------------------------------------------------------------------------------------------------
    */
    public function is_valid_nonce( $nonce = 'cpp_ajax_nonce' ){
        if( ! isset( $_POST['ajax_nonce'] ) || ! wp_verify_nonce( $_POST['ajax_nonce'], $nonce ) ){
            return false;
        }
        return true;
    }



    /*
    |---------------------------------------------------------------------------------------------------
    | Comprueba si una lista de un servicio es correcta
    |---------------------------------------------------------------------------------------------------
    */
    public function delete_consent_logs(){
        $response = array();
        $response['success'] = false;
        $response['message'] = __( 'Error: Unable to delete logs.', 'masterpopups' );

        if( ! is_admin() ){
            die();
        }

        if( ! isset( $_POST['logs'] ) ){
            wp_send_json( $response );
        }

        $total_consent_logs = wp_count_posts( $this->plugin->post_types['consent_logs'] );
        $total_consent_logs = $total_consent_logs ? $total_consent_logs->publish : 0;

        $logs = $_POST['logs'];
        $deleted = 0;
        foreach( $logs as $log_id ){
            $log_deleted = wp_delete_post( $log_id, true );
            if( $log_deleted ){
                $deleted++;
            }
        }
        $total_consent_logs -= $deleted;

        $response['success'] = true;
        $response['total'] = $total_consent_logs;
        $response['deleted'] = $deleted;

        if( $deleted > 1 ){
            $response['message'] = $deleted.' '.__( 'Logs successfully deleted.', 'masterpopups' );
        } else {
            $response['message'] = __( 'Log successfully deleted.', 'masterpopups' );
        }

        wp_send_json( $response );
    }


}
