<?php
$xbox->open_mixed_field( array(
    'name' => __( 'Show only in selected countries', 'mpp-cookieplus' ),
) );
$xbox->add_field( array(
    'id' => 'cookieplus-show-on-countries',
    'name' => __( 'Enable', 'mpp-cookieplus' ),
    'desc' => __( 'Activate this option and then select the countries in which you want to display the popup.', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['cookieplus-show-on-countries'],
    'grid' => '6-of-6',
) );
$xbox->add_field( array(
    'id' => 'cookieplus-show-countries',
    'name' => __( 'Countries', 'mpp-cookieplus' ),
    'type' => 'select',
    'default' => self::$defaults['cookieplus-show-countries'],
    'grid' => '6-of-6',
    'items' => XboxItems::countries(),
    'options' => array(
        'search' => true,
        'multiple' => true,
        'max_selections' => -1,
    ),
    'attributes' => array(
        'placeholder' => '- Select Countries -'
    )
) );
$xbox->add_field( array(
    'id' => 'cookieplus-show-on-eu-countries',
    'name' => __( 'European Union', 'mpp-cookieplus' ),
    'desc' => __( 'Activate this option to include countries of the European Union.', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['cookieplus-show-on-eu-countries'],
) );
$xbox->close_mixed_field();

$xbox->open_mixed_field( array(
    'name' => __( 'Hide only in selected countries', 'mpp-cookieplus' ),
) );
$xbox->add_field( array(
    'id' => 'cookieplus-hide-on-countries',
    'name' => __( 'Enable', 'mpp-cookieplus' ),
    'desc' => __( 'Activate this option and then select the countries in which you want to hide the popup.', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['cookieplus-hide-on-countries'],
    'grid' => '6-of-6',
) );
$xbox->add_field( array(
    'id' => 'cookieplus-hide-countries',
    'name' => __( 'Countries', 'mpp-cookieplus' ),
    'type' => 'select',
    'default' => self::$defaults['cookieplus-hide-countries'],
    'grid' => '6-of-6',
    'items' => XboxItems::countries(),
    'options' => array(
        'search' => true,
        'multiple' => true,
        'max_selections' => -1,
    ),
    'attributes' => array(
        'placeholder' => '- Select Countries -'
    )
) );
$xbox->add_field( array(
    'id' => 'cookieplus-hide-on-eu-countries',
    'name' => __( 'European Union', 'mpp-cookieplus' ),
    'desc' => __( 'Activate this option to include countries of the European Union.', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['cookieplus-hide-on-eu-countries'],
) );
$xbox->close_mixed_field();

