<?php

$xbox->add_field( array(
    'id' => 'cookie-consent-enabled',
    'name' => __( 'Enable Cookie Consent', 'mpp-cookieplus' ),
    'desc' => __( 'Enable this option to enable Cookie Consent functionality and start blocking cookies and scripts. If you deactivate, all enabled scripts will be loaded.', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['cookie-consent-enabled'],
) );

$block_all_text = __( 'Block All Cookies', 'mpp-cookieplus' );
$by_groups_text = __( 'Groups - Cookie Categories', 'mpp-cookieplus' );
$desc_consent_mode = "
<strong>$block_all_text : </strong>".__( 'All cookies will be blocked until the user accepts the cookies consent.', 'mpp-cookieplus' )."
<br><strong>$by_groups_text : </strong>".__( 'Only will be blocked the cookies and scripts by groups. Please enter the cookies and scripts you need to block in each group until the user accepts the cookies consent.', 'mpp-cookieplus' )."
";
$xbox->add_field( array(
    'id' => 'cookie-consent-mode',
    'name' => __( 'Cookie Consent Method', 'mpp-cookieplus' ),
    'desc' => $desc_consent_mode,
    'type' => 'radio',
    'default' => self::$defaults['cookie-consent-mode'],
    'items' => array(
        'block-all' => $block_all_text,
        'by-groups' => $by_groups_text
    )
) );

$xbox->open_mixed_field( array(
    'name' => __( 'Set Cookie', 'mpp-cookieplus' ),
    'desc' => __( 'This cookie is used when the user accepts cookies.', 'mpp-cookieplus' ),
) );
$xbox->add_field( array(
    'id' => 'cookie-consent-cookie-name',
    'name' => __( 'Cookie name', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['cookie-consent-cookie-name'],
    'grid' => '2-of-6',
) );
$xbox->add_field( array(
    'id' => 'cookie-consent-cookie-duration',
    'name' => __( 'Cookie duration', 'mpp-cookieplus' ),
    'type' => 'number',
    'default' => self::$defaults['cookie-consent-cookie-duration'],
    'options' => array(
        'desc_tooltip' => true,
        'show_spinner' => true,
        'unit' => 'days',
    ),
    'attributes' => array(
        'min' => 1,
    ),
) );
$xbox->close_mixed_field();

$xbox->add_field( array(
    'id' => 'cookie-settings-title',
    'name' => __( 'Title', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['cookie-settings-title'],
    'grid' => '3-of-8',
    'sanitize_callback' => false,
) );

$xbox->add_field( array(
    'id' => 'cookie-settings-content',
    'name' => __( 'Content', 'mpp-cookieplus' ),
    'type' => 'wp_editor',
    'default' => self::$defaults['cookie-settings-content'],
    'options' => array(
        'editor_height' => 180,
    ),
) );

$xbox->add_field( array(
    'id' => 'cookie-overview-tab-text',
    'name' => __( 'Privacy Overview', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['cookie-overview-tab-text'],
    'grid' => '2-of-8',
) );

$xbox->open_mixed_field( array( 'name' => __( 'Cookie Policy Link', 'mpp-cookieplus' ) ) );
$xbox->add_field( array(
    'id' => 'show-cookie-policy-tab',
    'name' => __( 'Show', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['show-cookie-policy-tab'],
) );
$xbox->add_field( array(
    'id' => 'cookie-policy-tab-text',
    'name' => __( 'Link Text', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['cookie-policy-tab-text'],
    'grid' => '2-of-8',
    'options' => array(
        'show_if' => array( 'show-cookie-policy-tab', '=', 'on' )
    ),
) );
$xbox->add_field( array(
    'id' => 'cookie-policy-tab-url',
    'name' => __( 'URL', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['cookie-policy-tab-url'],
    'grid' => '3-of-6',
    'options' => array(
        'show_if' => array( 'show-cookie-policy-tab', '=', 'on' )
    ),
) );
$xbox->close_mixed_field();


$xbox->add_field( array(
    'id' => 'btn-accept-cookies-text',
    'name' => __( 'Accept All Cookies Button', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['btn-accept-cookies-text'],
    'grid' => '2-of-8',
));
$xbox->add_field( array(
    'id' => 'btn-save-settings-text',
    'name' => __('Save Settings Button', 'mpp-cookieplus'),
    'type' => 'text',
    'default' => self::$defaults['btn-save-settings-text'],
    'grid' => '2-of-8',
));

$xbox->open_mixed_field(array('name' => __('Decline Cookies Button', 'mpp-cookieplus')));
$xbox->add_field( array(
    'id' => 'btn-decline-cookies-enabled',
    'name' => __( 'Show', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['btn-decline-cookies-enabled'],
) );
$xbox->add_field( array(
    'id' => 'btn-decline-cookies-text',
    'name' => __( 'Decline button text', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['btn-decline-cookies-text'],
    'grid' => '2-of-8',
));
$xbox->close_mixed_field();

$xbox->add_field( array(
    'id' => 'reload-on-save-cookies',
    'name' => __( 'Reload Page After Accept/Decline Cookies', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['reload-on-save-cookies'],
) );

$xbox->add_field( array(
    'id' => 'close-popup-on-save-cookies',
    'name' => __( 'Close Popup After Accept/Decline Cookies', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['close-popup-on-save-cookies'],
) );
$xbox->add_field( array(
    'id' => 'remove-cookies-after-decline',
    'name' => __( 'Remove Cookies After Decline', 'mpp-cookieplus' ),
    'desc' => __( 'If you activate this option, we will try to delete all cookies after decline cookies. Only the necessary cookies will not be deleted (Group 1)', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['remove-cookies-after-decline'],
) );



//$xbox->add_field( array(
//    'id' => 'show-popup-after-decline-cookies',
//    'name' => __( 'Show Popup After Decline Cookies', 'mpp-cookieplus' ),
//    'type' => 'switcher',
//    'default' => self::$defaults['show-popup-after-decline-cookies'],
//) );

$xbox->open_mixed_field(array(
    'name' => __('Wp Hook Priority for Scripts', 'mpp-cookieplus'),
    //'desc' => __( 'Used to specify the order in which the scripts are loaded.', 'mpp-cookieplus'),
));
$xbox->add_field( array(
    'id' => 'header-scripts-priority',
    'name' => __('Scripts in Head', 'mpp-cookieplus'),
    'type' => 'number',
    'default' => self::$defaults['header-scripts-priority'],
    'attributes' => array(
        'min' => 1
    ),
    'options' => array(
        'show_spinner' => true,
        'show_unit' => false,
    )
));
$xbox->add_field( array(
    'id' => 'footer-scripts-priority',
    'name' => __('Scripts in Footer', 'mpp-cookieplus'),
    'type' => 'number',
    'default' => self::$defaults['footer-scripts-priority'],
    'attributes' => array(
        'min' => 1
    ),
    'options' => array(
        'show_spinner' => true,
        'show_unit' => false,
    )
));
$xbox->close_mixed_field();


$xbox->add_field(array(
    'name' => __( 'Debug', 'mpp-cookieplus' ),
    'type' => 'title',
));
$xbox->add_field(array(
    'id' => 'debug-mode',
    'name' => __( 'Debug mode', 'mpp-cookieplus' ),
    'desc' => __( 'This option is only for developers, allows to see processes and errors in the console.', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['debug-mode'],
));
$xbox->add_field(array(
    'id' => 'debug-ip',
    'name' => 'IP',
    'type' => 'text',
    'default' => self::$defaults['debug-ip'],
    'desc' => __( 'IP for debug mode', 'mpp-cookieplus' ),
    'grid' => '4-of-8'
));