<?php

use MasterPopups\Includes\Functions;
use MasterPopups\Includes\Assets;

$xbox->open_mixed_field( array(
    'name' => __( 'Presentation', 'mpp-cookieplus' ),
) );
$xbox->add_field( array(
    'id' => 'presentation',
    'name' => __('Presentation mode', 'mpp-cookieplus'),
    'type' => 'select',
    'default' => self::$defaults['presentation'],
    'items' => array(
        'extended' => __('Tabs', 'mpp-cookieplus'),
        'compact' => __('Compact (Without Tabs)', 'mpp-cookieplus'),
        'combined' => __('Compact + Tabs', 'mpp-cookieplus'),
    ),
));
$xbox->add_field( array(
    'id' => 'show-cookie-tabs-text',
    'name' => __( 'Show details', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['show-cookie-tabs-text'],
    'grid' => '1-of-6',
    'options' => array(
        'show_if' => array('presentation', '=', 'combined')
    )
) );
$xbox->add_field( array(
    'id' => 'hide-cookie-tabs-text',
    'name' => __( 'Hide details', 'mpp-cookieplus' ),
    'type' => 'text',
    'default' => self::$defaults['hide-cookie-tabs-text'],
    'grid' => '1-of-6',
    'options' => array(
        'show_if' => array('presentation', '=', 'combined')
    )
) );
$xbox->close_mixed_field();

$xbox->add_field( array(
    'id' => 'theme',
    'name' => __('Theme', 'mpp-cookieplus'),
    'type' => 'select',
    'default' => self::$defaults['theme'],
    'items' => array(
        'classic' => __('Classic', 'mpp-cookieplus'),
        'modern' => __('Modern', 'mpp-cookieplus'),
    ),
));
$xbox->open_mixed_field( array(
    'name' => __( 'Logo', 'mpp-cookieplus' ),
) );
$xbox->add_field( array(
    'id' => 'default-logo',
    'name' => __('Default Logo', 'mpp-cookieplus'),
    'type' => 'image_selector',
    'default' => self::$defaults['default-logo'],
    'items' => array(
        'logo-privacy-center1.png' => CPMPP_URL.'assets/public/images/logo-privacy-center1.png',
        'logo-privacy-center2.png' => CPMPP_URL.'assets/public/images/logo-privacy-center2.png',
        'logo-privacy-center3.png' => CPMPP_URL.'assets/public/images/logo-privacy-center3.png',
        'logo-privacy-center4.png' => CPMPP_URL.'assets/public/images/logo-privacy-center4.png',
        'logo-upload.png' => CPMPP_URL.'assets/admin/images/logo-upload.png',
    ),
    'options' => array(
        'width' => '52px',
    ),
    'grid' => '5-of-8',
));
$xbox->add_field( array(
    'id' => 'custom-logo',
    'name' => __('Upload Logo', 'mpp-cookieplus'),
    'type' => 'file',
    'default' => self::$defaults['custom-logo'],
    'options' => array(
        'mime_types' => array( 'jpg', 'jpeg', 'png', 'gif', 'ico' ),
        'preview_size' => array( 'width' => '50px','height' => '50px' ),
        'multiple' => false,
        'show_if' => array('default-logo', '=', 'logo-upload.png')
    ),
    'grid' => '3-of-8',
));
$xbox->close_mixed_field();


$xbox->open_mixed_field(array(
    'name' => 'Font Family',
    'desc' => __( 'Activate this option to use a custom font. By default, is used the font of your current WordPress theme.', 'mpp-cookieplus' ),
));
$xbox->add_field( array(
    'id' => 'use-font-family',
    'name' => __( 'Enable', 'mpp-cookieplus' ),
    'type' => 'switcher',
    'default' => self::$defaults['use-font-family'],
) );
$xbox->add_field(array(
    'id' => 'font-family',
    'name' => 'Font family',
    'type' => 'select',
    'default' => self::$defaults['font-family'],
    'items' => array(
        'Fonts' => Assets::local_fonts(),
        'Google Fonts' => XboxItems::google_fonts(),
    ),
    'options' => array(
        'sort' => 'asc',
        'search' => true,
        'show_if' => array('use-font-family', '=', 'on')
    ),
));
$xbox->close_mixed_field();

$xbox->add_field(array(
    'id' => 'tab-menu-width',
    'name' => __('Menu Width', 'mpp-cookieplus'),
    'type' => 'number',
    'default' => self::$defaults['tab-menu-width'],
    'attributes' => array(
        'min' => 1,
    ),
    'options' => array(
        'show_spinner' => true,
        'unit' => 'px',
    )
));