<?php
$xbox->add_field( array(
    'id' => 'privacy-policy-page',
    'name' => __('Privacy Policy Page', 'mpp-cookieplus'),
    'type' => 'select',
    'default' => self::$defaults['privacy-policy-page'],
    'items' => array(
        '' => '- Select page -',
        'Pages' => $wp_pages,
    ),
    'options' => array(
        'sort' => 'asc',
        'sort_by_values' => true,
        'search' => true,
    ),
    'grid' => '3-of-6',
));
$xbox->add_field(array(
    'id' => 'privacy-policy-version',
    'name' => __( 'Version', 'masterpopups' ),
    'desc' => __( 'The version of your privacy policy. If you change it, users have to accept them again', 'masterpopups' ),
    'type' => 'text',
    'default' => self::$defaults['privacy-policy-version'],
    'grid' => '1-of-6',
));

$xbox->open_mixed_field(array(
    'name' => __('Shortcodes', 'mpp-cookieplus'),
));
$shortcode_policy = '';
$shortcode_policy .= '<textarea class="ampp-input-selector" readonly style="display: block; width: 100%; height: 76px;">';
$shortcode_policy .= '[cookieplus_btn_accept_policy]Accept Policy[/cookieplus_btn_accept_policy]';
$shortcode_policy .= "\n";
$shortcode_policy .= '[cookieplus_btn_accept_policy id="custom-id" class="custom-class other-class" radius="0px"]Accept Policy[/cookieplus_btn_accept_policy]';
$shortcode_policy .= '</textarea>';

$xbox->add_field(array(
    'id' => 'privacy-policy-shortcode',
    'name' => __('Shortcode', 'mpp-cookieplus'),
    'type' => 'html',
    'content' => $shortcode_policy,
    'grid' => '8-of-8',
));
$xbox->add_field(array(
    'id' => 'privacy-policy-shortcode-auto',
    'name' => __('Insert shortcode automatically', 'mpp-cookieplus'),
    'desc' => __('We will try to add the short code automatically to the end of the previously selected page.', 'mpp-cookieplus'),
    'type' => 'switcher',
    'default' => self::$defaults['privacy-policy-shortcode-auto'],
    'grid' => '8-of-8',
));
$xbox->add_field(array(
    'id' => 'privacy-policy-shortcode-auto-text',
    'name' => __('Text', 'mpp-cookieplus'),
    'type' => 'text',
    'default' => self::$defaults['privacy-policy-shortcode-auto-text'],
    'grid' => '2-of-6',
    'options' => array(
        'show_if' => array('privacy-policy-shortcode-auto', '=', 'on'),
    )
));
$xbox->close_mixed_field();

$xbox->add_field( array(
    'name' => __('After user accepts:', 'mpp-cookieplus'),
    'type' => 'title',
));

$xbox->add_field( array(
    'id' => 'privacy-policy-redirect-page',
    'name' => __('Redirect to', 'mpp-cookieplus'),
    'desc' => __('Enter a valid URL', 'mpp-cookieplus'),
    'type' => 'text',
    'default' => self::$defaults['privacy-policy-redirect-page'],
    'grid' => '3-of-6',
));
$xbox->open_mixed_field(array(
    'name' => __('Set Cookie', 'mpp-cookieplus'),
));
$xbox->add_field( array(
    'id' => 'privacy-policy-cookie-name',
    'name' => __('Cookie name', 'mpp-cookieplus'),
    'type' => 'text',
    'default' => self::$defaults['privacy-policy-cookie-name'],
    'grid' => '2-of-6',
));
$xbox->add_field(array(
    'id' => 'privacy-policy-cookie-duration',
    'name' => __( 'Cookie duration', 'masterpopups' ),
    'type' => 'number',
    'default' => self::$defaults['privacy-policy-cookie-duration'],
    'options' => array(
        'desc_tooltip' => true,
        'show_spinner' => true,
        'unit' => 'days',
    ),
    'attributes' => array(
        'min' => 1,
    ),
));
$xbox->close_mixed_field();

$xbox->add_field( array(
    'id' => 'privacy-policy-save-userdata',
    'name' => __('Save in the user data', 'mpp-cookieplus'),
    'desc' => __('If the user is logged-in, save cookie data in the user data', 'mpp-cookieplus'),
    'type' => 'switcher',
    'default' => self::$defaults['privacy-policy-save-userdata'],
    'grid' => '2-of-6',
));

$xbox->add_field( array(
    'id' => 'privacy-policy-thanks-message',
    'name' => __('Display message', 'mpp-cookieplus'),
    'desc' => __('This message will be displayed when the user has already accepted the privacy policy.', 'mpp-cookieplus'),
    'type' => 'textarea',
    'default' => self::$defaults['privacy-policy-thanks-message'],
    'grid' => '3-of-6',
));

