<?php
$xbox->add_field( array(
    'id' => 'terms-conditions-page',
    'name' => __('Terms and Conditions Page', 'mpp-cookieplus'),
    'type' => 'select',
    'default' => self::$defaults['terms-conditions-page'],
    'items' => array(
        '' => '- Select page -',
        'Pages' => $wp_pages,
    ),
    'options' => array(
        'sort' => 'asc',
        'sort_by_values' => true,
        'search' => true,
    ),
    'grid' => '3-of-6',
));
$xbox->add_field(array(
    'id' => 'terms-conditions-version',
    'name' => __( 'Version', 'masterpopups' ),
    'desc' => __( 'The version of your terms and conditions. If you change it, users have to accept them again', 'masterpopups' ),
    'type' => 'text',
    'default' => self::$defaults['terms-conditions-version'],
    'grid' => '1-of-6',
));

$xbox->open_mixed_field(array(
    'name' => __('Shortcodes', 'mpp-cookieplus'),
));
    $shortcode_terms = '';
    $shortcode_terms .= '<textarea class="ampp-input-selector" readonly style="display: block; width: 100%; height: 76px;">';
    $shortcode_terms .= '[cookieplus_btn_accept_terms]Accept Terms[/cookieplus_btn_accept_terms]';
    $shortcode_terms .= "\n";
    $shortcode_terms .= '[cookieplus_btn_accept_terms id="custom-id" class="custom-class other-class" radius="0px"]Accept Terms[/cookieplus_btn_accept_terms]';
    $shortcode_terms .= '</textarea>';

    $xbox->add_field(array(
        'id' => 'terms-conditions-shortcode',
        'name' => __('Shortcode', 'mpp-cookieplus'),
        'type' => 'html',
        'content' => $shortcode_terms,
        'grid' => '8-of-8',
    ));
    $xbox->add_field(array(
        'id' => 'terms-conditions-shortcode-auto',
        'name' => __('Insert shortcode automatically', 'mpp-cookieplus'),
        'desc' => __('We will try to add the short code automatically to the end of the previously selected page.', 'mpp-cookieplus'),
        'type' => 'switcher',
        'default' => self::$defaults['terms-conditions-shortcode-auto'],
        'grid' => '8-of-8',
    ));
    $xbox->add_field(array(
        'id' => 'terms-conditions-shortcode-auto-text',
        'name' => __('Text', 'mpp-cookieplus'),
        'type' => 'text',
        'default' => self::$defaults['terms-conditions-shortcode-auto-text'],
        'grid' => '2-of-6',
        'options' => array(
            'show_if' => array('terms-conditions-shortcode-auto', '=', 'on'),
        )
    ));
$xbox->close_mixed_field();


$xbox->add_field( array(
    'name' => __('After user accepts:', 'mpp-cookieplus'),
    'type' => 'title',
));

$xbox->add_field( array(
    'id' => 'terms-conditions-redirect-page',
    'name' => __('Redirect to', 'mpp-cookieplus'),
    'desc' => __('Enter a valid URL', 'mpp-cookieplus'),
    'type' => 'text',
    'default' => self::$defaults['terms-conditions-redirect-page'],
    'grid' => '3-of-6',
));
$xbox->open_mixed_field(array(
    'name' => __('Set Cookie', 'mpp-cookieplus'),
));
    $xbox->add_field( array(
        'id' => 'terms-conditions-cookie-name',
        'name' => __('Cookie name', 'mpp-cookieplus'),
        'type' => 'text',
        'default' => self::$defaults['terms-conditions-cookie-name'],
        'grid' => '2-of-6',
    ));
    $xbox->add_field(array(
        'id' => 'terms-conditions-cookie-duration',
        'name' => __( 'Cookie duration', 'masterpopups' ),
        'type' => 'number',
        'default' => self::$defaults['terms-conditions-cookie-duration'],
        'options' => array(
            'desc_tooltip' => true,
            'show_spinner' => true,
            'unit' => 'days',
        ),
        'attributes' => array(
            'min' => 1,
        ),
    ));
$xbox->close_mixed_field();

$xbox->add_field( array(
    'id' => 'terms-conditions-save-userdata',
    'name' => __('Save in the user data', 'mpp-cookieplus'),
    'desc' => __('If the user is logged-in, save cookie data in the user data', 'mpp-cookieplus'),
    'type' => 'switcher',
    'default' => self::$defaults['terms-conditions-save-userdata'],
    'grid' => '2-of-6',
));

$xbox->add_field( array(
    'id' => 'terms-conditions-thanks-message',
    'name' => __('Display message', 'mpp-cookieplus'),
    'desc' => __('This message will be displayed when the user has already accepted the terms and conditions.', 'mpp-cookieplus'),
    'type' => 'textarea',
    'default' => self::$defaults['terms-conditions-thanks-message'],
    'grid' => '3-of-6',
));
